<?php

if(!defined('EXT'))
{
	exit('Invalid file request');
}

class User_registration_redirect {

	var $settings = array();
	var $name = 'User Registration Redirect';
	var $version = '0.1';
	var $description = 'Redirect user after user registration';
	var $settings_exist = 'n';
	var $docs_url = '';

	function User_registration_redirect($settings = '')
	{
		$this->settings = $settings;
	}

	function redirect_registered_user()
	{
        global $IN, $FNS, $OUT, $DB, $PREFS, $SESS, $REGX, $LANG, $STAT, $EXT;

		$EXT->end_script = TRUE;
	
		if ($PREFS->ini('req_mbr_activation') == 'email')
		{
			$qs = ($PREFS->ini('force_query_string') == 'y') ? '' : '?';        
			
			$action_id  = $FNS->fetch_action_id('Member', 'activate_member');
		
			$name = ($data['screen_name'] != '') ? $data['screen_name'] : $data['username'];
		
			$forum_id = ($IN->GBL('FROM') == 'forum') ? '&r=f' : '';
			
			$add = ($mailinglist_subscribe !== TRUE) ? '' : '&mailinglist='.$_POST['mailinglist_subscribe']; 
				
			$swap = array(
							'name'				=> $name,
							'activation_url'	=> $FNS->fetch_site_index(0, 0).$qs.'ACT='.$action_id.'&id='.$data['authcode'].$forum_id.$add,
							'site_name'			=> stripslashes($PREFS->ini('site_name')),
							'site_url'			=> $PREFS->ini('site_url'),
							'username'			=> $data['username'],
							'email'				=> $data['email']
						 );
			
			$template = $FNS->fetch_email_template('mbr_activation_instructions');
			$email_tit = $this->_var_swap($template['title'], $swap);
			$email_msg = $this->_var_swap($template['data'], $swap);
                                                
            /** ----------------------------
            /**  Send email
            /** ----------------------------*/
            
            if ( ! class_exists('EEmail'))
            {
				require PATH_CORE.'core.email'.EXT;
            }
                 
            $email = new EEmail;
            $email->wordwrap = true;
            $email->from($PREFS->ini('webmaster_email'), $PREFS->ini('webmaster_name'));	
            $email->to($data['email']); 
            $email->subject($email_tit);	
            $email->message($REGX->entities_to_ascii($email_msg));		
            $email->Send();
            
            $message = $LANG->line('mbr_membership_instructions_email');		
        }
        elseif ($PREFS->ini('req_mbr_activation') == 'manual')
        {
			$message = $LANG->line('mbr_admin_will_activate');
        }	
		else
		{
			/** ----------------------------------------
			/**  Log user in
			/** ----------------------------------------*/
				
			$expire = 60*60*24*182;
					
			$FNS->set_cookie($SESS->c_expire , time()+$expire, $expire);
			$FNS->set_cookie($SESS->c_uniqueid , $data['unique_id'], $expire);       
			$FNS->set_cookie($SESS->c_password , $data['password'],  $expire);   

			/** ----------------------------------------
			/**  Create a new session
			/** ----------------------------------------*/
			
			if ($PREFS->ini('user_session_type') == 'cs' || $PREFS->ini('user_session_type') == 's')
			{  
				$SESS->sdata['session_id'] = $FNS->random();  
				$SESS->sdata['member_id']  = $member_id;  
				$SESS->sdata['last_activity'] = $LOC->now;  
								
				$FNS->set_cookie($SESS->c_session , $SESS->sdata['session_id'], $SESS->session_length);   
				
				$DB->query($DB->insert_string('exp_sessions', $SESS->sdata));          
			}
			
			/** ----------------------------------------
			/**  Update existing session variables
			/** ----------------------------------------*/
			
			$SESS->userdata['username']  = $data['username'];
			$SESS->userdata['member_id'] = $member_id;
		
			/** ----------------------------------------
			/**  Update stats
			/** ----------------------------------------*/
	 
			$cutoff		= $LOC->now - (15 * 60);
			$weblog_id	= (USER_BLOG !== FALSE) ? UB_BLOG_ID : 0;
	
			$DB->query("DELETE FROM exp_online_users WHERE (ip_address = '$IN->IP' AND member_id = '0') OR (date < $cutoff AND weblog_id = '$weblog_id')");				
				
			$data = array(
							'weblog_id'		=> $weblog_id,
							'member_id'		=> $SESS->userdata('member_id'),
							'name'			=> ($SESS->userdata['screen_name'] == '') ? $SESS->userdata['username'] : $SESS->userdata['screen_name'],
							'ip_address'	=> $IN->IP,
							'date'			=> $LOC->now,
							'anon'			=> 'y'
						);
		   
			$DB->query($DB->update_string('exp_online_users', $data, array("ip_address" => $IN->IP, "member_id" => $data['member_id'], "weblog_id" => $data['weblog_id'])));
			
			$message = $LANG->line('mbr_your_are_logged_in');
		}
    	
        
        /** ----------------------------------------
        /**  Build the message
        /** ----------------------------------------*/
		
		if ($IN->GBL('FROM') == 'forum')
		{
			$query		= $DB->query("SELECT pref_forum_name, pref_forum_url FROM exp_forum_prefs WHERE pref_id='1'");			
			$site_name	= $query->row['pref_forum_name'];
			$return		= $query->row['pref_forum_url'];
		}
		else
		{
			$site_name = ($PREFS->ini('site_name') == '') ? $LANG->line('back') : stripslashes($PREFS->ini('site_name'));
			$return = $PREFS->ini('site_url');
		}
		
        $data = array(	'title' 	=> $LANG->line('mbr_registration_complete'),
        				'heading'	=> $LANG->line('thank_you'),
        				'content'	=> $LANG->line('mbr_registration_completed')."\n\n".$message,
        				'redirect'	=> $SESS->tracker[3],
        				'link'		=> array($return, $site_name)
        			 );
			
		$OUT->show_message($data);		

	}

	function activate_extension()
	{
		global $DB;

		$DB->query($DB->insert_string('exp_extensions',
				array(
				'extension_id'	=> '',
				'class'			=> "User_registration_redirect",
				'method'		=> "redirect_registered_user",
				'hook'			=> "member_member_register",
				'settings'		=> "",
				'priority'		=> 10,
				'version'		=> $this->version,
				'enabled'		=> "y"
				)
			)
		);
	}


	function disable_extension()
	{
		global $DB;

		$DB->query("DELETE FROM exp_extensions WHERE class = 'User_registration_redirect'");
	}
}
?>